package org.jk.rag.service.impl;

import org.jk.common.core.utils.MapstructUtils;
import org.jk.common.core.utils.StringUtils;
import org.jk.common.mybatis.core.page.TableDataInfo;
import org.jk.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.jk.rag.domain.SysTokenLog;
import org.jk.rag.domain.bo.SysTokenLogBo;
import org.jk.rag.domain.vo.SysTokenLogVo;
import org.jk.rag.mapper.SysTokenLogMapper;
import org.jk.rag.service.ISysTokenLogService;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 在线人数记录Service业务层处理
 *
 * @author Lion Li
 * @date 2026-01-27
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class SysTokenLogServiceImpl implements ISysTokenLogService {

    private final SysTokenLogMapper baseMapper;

    /**
     * 查询在线人数记录
     *
     * @param id 主键
     * @return 在线人数记录
     */
    @Override
    public SysTokenLogVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询在线人数记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 在线人数记录分页列表
     */
    @Override
    public TableDataInfo<SysTokenLogVo> queryPageList(SysTokenLogBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SysTokenLog> lqw = buildQueryWrapper(bo);
        Page<SysTokenLogVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的在线人数记录列表
     *
     * @param bo 查询条件
     * @return 在线人数记录列表
     */
    @Override
    public List<SysTokenLogVo> queryList(SysTokenLogBo bo) {
        LambdaQueryWrapper<SysTokenLog> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SysTokenLog> buildQueryWrapper(SysTokenLogBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SysTokenLog> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(SysTokenLog::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getTokenSpeed()), SysTokenLog::getTokenSpeed, bo.getTokenSpeed());
        lqw.eq(StringUtils.isNotBlank(bo.getElapsedTime()), SysTokenLog::getElapsedTime, bo.getElapsedTime());
        return lqw;
    }

    /**
     * 新增在线人数记录
     *
     * @param bo 在线人数记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SysTokenLogBo bo) {
        SysTokenLog add = MapstructUtils.convert(bo, SysTokenLog.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改在线人数记录
     *
     * @param bo 在线人数记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SysTokenLogBo bo) {
        SysTokenLog update = MapstructUtils.convert(bo, SysTokenLog.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SysTokenLog entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除在线人数记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    @Override
    public List<SysTokenLogVo> queryThirtyDayData() {
        return baseMapper.queryThirtyDayData();
    }

    @Override
    public List<SysTokenLogVo> queryTwelveMonthData() {
        return baseMapper.queryTwelveMonthData();
    }
}
